char *readall(int fd,size_t *s_return)/*free result*/
{	char *out=0 ;ssize_t s;size_t len=0;
	while(1)
{		out=realloc(out,len+512);
		s=read(fd,out+len,512);if(s<0)break;
		else if(s==0)break;
		else len+=s;
}	if(s_return)*s_return=len;
	out=realloc(out,len+1);
	out[len]='\0';return out
;
}/*from core.h*/;
#ifndef PAGE_SIZE
#define PAGE_SIZE 16384
#endif

/*from link.h*/;
const char AppObj = 0x14;
const char AppVarObj = 0x15
;
/*ref. wxwabbitemu/utilities/exportvar.c*/
;
#define intelhex(a,b,c) intelhex_f(a,b,c,0,0x4000)
void intelhex_f (int, const unsigned char*, int size, int page, int start_address)
;
const char flashheader[] = {
	'*','*','T','I','F','L','*','*'}
;
typedef unsigned char uint8_t;
#define _T(S) S
#define TCHAR char
#define mprintf dprintf
int mputc(char c,int fd)
{	ssize_t s1=write(fd,&c,1);if(s1<0)s1=0;return (int)s1;
}void b_ExportApp(char *fn,char *name)
{	int outfile;
	size_t s1;
	char *mem=readall(0,&s1);
	unsigned int tempnum;
	int page_count=s1/PAGE_SIZE+(s1%PAGE_SIZE?1:0),page_mod=s1%PAGE_SIZE?s1%PAGE_SIZE:PAGE_SIZE;
	int i, data_size = PAGE_SIZE * page_count;
	uint8_t *buffer = (uint8_t *) realloc(mem,data_size);
	memset(buffer+data_size-(PAGE_SIZE-page_mod), -1, PAGE_SIZE-page_mod);
	/*uint8_t *temp_point = buffer;
	for (tempnum = page; tempnum > page - page_count; tempnum--)
{		u_char (*dest)[PAGE_SIZE] = (u_char (*)[PAGE_SIZE]) mem;
		memcpy(temp_point, &dest[tempnum], PAGE_SIZE);
}	*	temp_point += PAGE_SIZE*/;
	outfile = open(fn,O_WRONLY|O_CREAT|O_TRUNC);if(outfile>=0);else return;
	// Lots of pointless header crap;
	for(i = 0; i < 8; i++) mputc(flashheader[i], outfile);
	//version, major.minor;
	mputc(0x01, outfile);
	mputc(0x01, outfile);
	//flags;
	mputc(0x01, outfile);
	//object type;
	mputc(0x88, outfile);
	//date;
	mputc(0x01, outfile);
	mputc(0x01, outfile);
	mputc(0x19, outfile);
	mputc(0x97, outfile);
	//name length...wtf? its always 8;
	mputc(0x08, outfile);
	//name;
	for (i = 0; i < 8 && name[i]; i++) mputc(name[i], outfile);
	for(;i < 8; i++) mputc(0, outfile);
	//filler;
	for (i = 0; i < 23; i++) mputc(0x00, outfile);
	//device;
	mputc(0x73, outfile);
	//its an app not an OS/cert/license;
	mputc(0x24, outfile);
	//filler;
	for (i = 0; i < 24; i++) mputc(0x00, outfile);
	//size of Intel hex;
	tempnum =  77 * (data_size >> 5) + page_count * 17 + 11;
	int size = data_size & 0x1F;
	if (size) tempnum += (size << 1) + 13;
	mputc(tempnum & 0xFF, outfile);	//little endian;
	mputc((tempnum >> 8) & 0xFF, outfile);
	mputc((tempnum >> 16) & 0xFF, outfile);
	mputc(tempnum >> 24, outfile);
	//data;
	dprintf(2,"page count = %d ,page size = %d\n",page_count,PAGE_SIZE);
	intelhex(outfile, buffer, data_size);
	mprintf(outfile, _T(":00000001FF"));
	//checksum;
	mputc(0, outfile);mputc(0, outfile);
}/* Convert binary buffer to Intel hex in TI format
{ * All pages are only $4000 bytes long.;
 * stolen from spasm's export.c  to make my 1/2 hour deadline;
}**/;
void intelhex_f (int outfile, const unsigned char* buffer, int size, int page, int start_address)
{	const TCHAR hexstr[] = _T("0123456789ABCDEF");
	int bpnt = 0;
	unsigned int address, ci, temp, i;
	unsigned char chksum;
	unsigned char outbuf[128]
;
	//We are in binary mode, we must handle carriage return ourselves.
;
	while (bpnt < size)
{		dprintf(2,"page = %02X\n",page);
		mprintf(outfile, _T(":02000002%04X%02X\r\n"), page & 0x1F, (unsigned char) ((~(0x04 + page)) + 1));
		page++;
		address = start_address;
		for (i = 0; bpnt < size && i < 512; i++)
{			chksum = (address >> 8) + (address & 0xFF);
			for(ci = 0; (ci < 64) && (bpnt < size); ci++)
{				temp = buffer[bpnt++];
				outbuf[ci++] = hexstr[temp >> 4];
				outbuf[ci] = hexstr[temp & 0x0F];
				chksum += temp;
}			outbuf[ci] = 0;
			ci >>= 1;
			mprintf(outfile, _T(":%02X%04X00%s%02X\r\n"), ci, address, outbuf, (unsigned char)(~(chksum + ci) + 1));
			address += 0x20;
}}}int main(int argc,char **argv)
{	if(argc<3)return 1;
	b_ExportApp(argv[1],argv[2]);
	return 0;
}//cpp.py b2e;gcc b2e.c -o b2e -include syslib.h -Wall|& gccw;
