struct undo_action;
typedef tlist_t(struct undo_action *) tlist_t_undo_action;
typedef struct hist
{	tlist_t_undo_action arr;int len1;
}hist_t;//;
struct undo_action
{	void *a;
	char continu,replaceable;
	void (*unact)(hist_t *hist,char op/*0*/,void *out_p);
	void (*react)(hist_t *hist,char op/*1*/,void *out_p);
	void *(*new)();
	void (*free)(void *unknown);
};//;
//use if(out_p);
#define ua_head(off) ua_head_(hist,off)
int ua_head_(hist_t *hist,int off)
{	while(off>1&&hist->arr.a[off].continu)off-=1;return off;
}//push_undo call next with tail=1 then add an item;
void reset_undo(hist_t *hist,char tail)
{	int end=tail?hist->len1:0;
	int n=hist->arr.len;while(n>end)
{		struct undo_action *ua=hist->arr.a+n;
		ua->free(ua);
		n-=1;
}	if(!tail)hist->len1=0;
	hist->arr.len=hist->len1;
}char unact_undo(hist_t *hist,void *out_p)
{	if(hist->len1)
{		int head=ua_head(hist->len1);while(head<=hist->len1)
{			hist->arr.a[hist->len1].unact(hist,0,(head==hist->len1)?out_p:NULL);
			hist->len1-=1;
}}	return (hist->len1?1:0);
}char react_undo(hist_t *hist,void *out_p)
{	if(hist->len1<hist->arr.len)
{		char is_head=(hist->arr.a[hist->len1].continu==0),first=1;while(1)
{			hist->arr.a[hist->len1].react(hist,1,first?out_p:NULL);
			hist->len1+=1;if(hist->len1<hist->arr.len);else break;
			if(is_head);else break;if(hist->arr.a[hist->len1].continu==0)break ;first=0;
}}	return (hist->len1<hist->arr.len?1:0);
}void *push_undo(hist_t *hist,struct undo_action temp,char continu,char replaceable)/*call react_undo after this*/
{	struct undo_action ua_v;
	ua_v=temp;ua_v.a=ua_v.new();
	if(hist->len1>0)
{		struct undo_action *ua=&hist->arr.a[ua_head(hist->len1)];
		if(replaceable&&ua->replaceable)
{			unact_undo(hist,NULL) ;continu=0;
}}	ua_v.continu=continu;ua_v.replaceable=replaceable;
	reset_undo(hist,1/*tail*/);
	tlistpe(hist->arr,ua_v)/*;hist->len1+=1*/;
	return ua_v.a;}
#undef ua_head
#ifdef action_template_1
struct name_act
{	//;
};//;
struct undo_action name_ua_v;
void *name_act_new()
{	struct name_act *ext=malloc(sizeof(struct name_act));
	return ext;
}static void name_act_free(void *unknown)
{	struct name_act *ext=unknown;free(ext);
}static void name_xact(hist_t *hist,char op/*0 unact 1 react*/,void *out_p)
{	//;
}void name_act(hist_t *hist,char op)
{	struct name_act *ext=push_undo(hist,name_ua_v,0,0);
	//;
	react_undo(hist,NULL);
}struct undo_action name_ua_v={.unact=&name_xact,.react=&name_xact,.new=&name_act_new,.free=&name_act_free};
#endif
pid_t waitpid_ex(pid_t pid, int *ex, int options)
{	int status;pid_t ret=waitpid(pid,!ex?ex:&status,options);
	if(ret==(pid_t)-1);else if(ex)
{		if(WIFEXITED(status))*ex=WEXITSTATUS(status);
}	return ret
;
}char *readall(int fd,size_t *s_return)/*free result*/;
char *read_cmd(char *cmd)
{	char *out=NULL;
	int res;int pipefd[2];int fdin;
	res=pipe(pipefd);
	pid_t pid=fork();if(!pid)
{		close(pipefd[0]);dup2(pipefd[1],1);
		system(cmd);_exit(0);
}	else if(pid>0)
{		close(pipefd[1]);fdin=pipefd[0]/*;set_nb(fdin)*/;
		out=readall(fdin,NULL);
		close(fdin);
		/*kill(pid,SIGTERM)*/;
		waitpid_ex(pid,NULL,0);
}	else
{		close(pipefd[0]);close(pipefd[1]);
}	if(!out)out=strdup("");return out
;
}pid_t cmd_pipe(char **av,int pipefd[2]/*input: 0 none 1 pipe 2 close*/,char close2)
{	int res;int pipefd0[2],pipefd1[2],pipefd_o[]={-1,-1};
	if(pipefd[0]==1)res=pipe(pipefd0);
	if(pipefd[1]==1)res=pipe(pipefd1);
	pid_t pid=fork();if(!pid)
{		if(pipefd[0]==1)
{			close(pipefd0[1]);dup2(pipefd0[0],0);
}		else if(pipefd[0]==2)close(0);
		if(pipefd[1]==1)
{			close(pipefd1[0]);dup2(pipefd1[1],1);
}		else if(pipefd[1]==2)close(1);
		if(close2)close(2);
		execvp(av[0],av);_exit(-1);
}	else if(pid>0)
{		if(pipefd[0]==1)
{			close(pipefd0[0]);pipefd_o[1]=pipefd0[1];
}		if(pipefd[1]==1)
{			close(pipefd1[1]);pipefd_o[0]=pipefd1[0];
}		//kill(pid,SIGTERM);
		//int ex;waitpid_ex(pid,&ex,0);
}	else
{		pid=0;
		if(pipefd[0]==1)
{			close(pipefd0[0]);close(pipefd0[1]);
}		if(pipefd[1]==1)
{			close(pipefd1[0]);close(pipefd1[1]);
}}	pipefd[0]=pipefd_o[0];pipefd[1]=pipefd_o[1];return pid
;
}int cmd_run(char **av,char close0,char close1,char close2)
{	int cmd_pipefd[]={0,0};if(close0)cmd_pipefd[0]=2;if(close1)cmd_pipefd[1]=2;
	pid_t pid=cmd_pipe(av,cmd_pipefd,close2);
	int ex=-1;if(pid)waitpid_ex(pid,&ex,0);return ex
;
}char *read_cmdv(char **av,char close0)
{	char *out=NULL;
	int cmd_pipefd[]={0,1};if(close0)cmd_pipefd[0]=2;
	pid_t pid=cmd_pipe(av,cmd_pipefd,0/*close2*/);if(pid)
{		out=readall(cmd_pipefd[0],NULL);close(cmd_pipefd[0]);
		waitpid_ex(pid,NULL,0);
}	if(!out)out=strdup("");return out
;
}int cmd_run1(char **av,char close0)
{	int ex=-1;
	pid_t pid=fork();if(!pid)
{		if(close0)close(0);
		execvp(av[0],av);_exit(-1);
}	else if(pid>0)
{		//kill(pid,SIGTERM);
		waitpid_ex(pid,&ex,0);
}	else
{		//;
}	return ex;
}char *readall(int fd,size_t *s_return)/*free result*/
{	char *out=0 ;ssize_t s;size_t len=0;
	while(1)
{		out=realloc(out,len+512);
		s=read(fd,out+len,512);if(s<0)break;
		else if(s==0)break;
		else len+=s;
}	if(s_return)*s_return=len;
	out=realloc(out,len+1);
	out[len]='\0';return out;
}void writeall(int fd,char *buf,size_t s)
{	while(s>=512)
{		write(fd,buf,512);s-=512;buf+=512;
}	if(s)write(fd,buf,s)
;}
#define readline(fdi,end_io) ewrap(readline_dup(fdi,end_io))
char *readline_dup(int fdi,char *end_io/*init. to {'\0','\0'}*/)
{	/*a blocking, ia. input stream should return asap.;
	if the next char. is ignored, might have to adjust offset (if(eol[0]=='\n'))*/;
	/*end_io[0] will be '\n' if leading '\n' ignored else '\0';
	end_io[1] will be '\r' '\n' or '\0'*/;
	/*strips line end, deref'd value is malloc'd null-terminated string or NULL, if free also set to NULL.*/;
	char *out=malloc(0x10);/**out='\0';*/int len_out=0;char c;size_t size1;
	end_io[0]='\0';
	while((size1=read(fdi,&c,1))>0){if(c=='\r'){end_io[1]=c;break;}else if(c=='\n'){if(end_io[1]=='\r'){end_io[0]=c;end_io[1]=c;}else{end_io[1]=c;break;}}else{len_out+=1;if((len_out+1)%0x10==0)out=realloc(out,len_out+1+0x10);out[len_out-1]=c;}};
	if(size1>0)out[len_out]='\0';else {end_io[1]='\0';if(len_out>0)out[len_out]='\0';else {free(out);out=NULL;}};
	return out;
}void freadline(int fdi,void *callback_fun)
{	ssize_t sbuf,s1;
	#define mbuf 1000
	char buf[mbuf];char *beg,*end;char *line=malloc(10);*line='\0';int len_line=0
;
	while(1){;
	sbuf=read(fdi,buf,/*SSIZE_MAX*/mbuf);
	if(sbuf<1){ if(len_line>0)goto trail;else break;};
	beg=buf;
	while(1){;
	end=memchr(beg,'\n',buf+sbuf-beg);
	s1=(end?end+1-beg:buf+sbuf-beg);
	line=realloc(line,len_line+s1+1);
	strncpy(line+len_line,beg,s1);len_line+=s1;line[len_line]='\0';
	if(!end)break;trail:
;
	if(((char (*)(char *)) callback_fun)(line)||sbuf<1)goto fit
;
	*line='\0';len_line=0;
	beg=end+1;
	}
;
	};
	fit:;
	free(line)
;}
#define read_int_q(fd) ({int macres;read(fd,&macres,sizeof(int));macres;})
#define write_int_q(fd,val) ({int macres=val;write(fd,&macres,sizeof(int));macres;})
//typedef char *str/*use str **/;
/*changed: strreadline returned "\n\0" always, some old code may still expect that*/;
#define strreadline_dup(a_p,end_io) ({char **macres1=strreadline_imp(a_p,end_io),*macres2=macres1[0];macres1[0]=NULL;macres2;})
#define strreadline(a_p,end_io) strreadline_imp(a_p,end_io)[0]
char **strreadline_imp(char **a_p,char *end_io/*init. to {'\r','\n'}*/)
{	/*end_io will be {'\r',char} {'\0','\n'} {'\r','\n'} or {'\0','\0'} might want if(eol[0]=='\r'&&eol[1]!='\n'&&eol[1]!='\0')a-1*/;
	/*strips line end. deref'd return value is malloc'd null-terminated string or NULL*/;
	//ref. fm/fm/from_wikigen/read.c which was also copied from somewhere, folder "cmds";
	static char *out,*out2;if(!out)out=malloc(0x10);/**out='\0';*/int len_out=0;char c ;char last=0;
	if(end_io[0]=='\r'&&end_io[1]!='\n'){c=end_io[1];end_io[1]='\n';goto back;};
	while(({c=**a_p;*a_p+=(c!='\0');c;})!='\0'){back:;if(last){end_io[1]=c;break;}if(c=='\r'){end_io[0]=c;last=1;}else if(c=='\n'){end_io[0]='\0';end_io[1]=c;break;}else{len_out+=1;if((len_out+1)%0x10==0)out=realloc(out,len_out+1+0x10);out[len_out-1]=c;}};
	if(c!='\0')out[len_out]='\0';else {if(!last)end_io[0]='\0';end_io[1]='\0';if(len_out>0)out[len_out]='\0';else return &out2;};
	return &out;
}char **strline(char *a)/*free result, returns NULL-terminated array of s e pointers*/
{	char **out=malloc(sizeof(char *));int len_out=0;char *a1=a,*s,*e;
	#define c a[0]
	while(1)
{		s=a;while(1)
{			if(c=='\0')
{				e=a;break;
}			if(c=='\r')
{				e=a;a+=1;if(c=='\n')a+=1;break;
}			else if(c=='\n')
{				e=a;a+=1;break;
}			a+=1;
}		if(e<a||s<e)
{			len_out+=2;out=realloc(out,sizeof(char *)*(len_out+1));
			out[len_out-2]=s;out[len_out-1]=e;
}		if(c=='\0')break;
}	out[len_out]=NULL;return out;
	#undef c
}char rangechr(char *a,char c)
{	if(a[0]<=c&&c<=a[1])return 1;else return 0;
	//strchr should (doesn't) return NULL if c='\0';
	//maybe specify list of characters then translate to list of ranges;
}void str_replace_c(char *s,char a,char b,char dir/*bit 1 a with b bit 2 b with a*/)
{	while(*s)
{		char c=*s;
		if((dir&1)&&c==a)*s=b;if((dir&2)&&c==b)*s=a;s+=1;
}}char *cut(char *s,int field,char delim)/*free result*/
{	char *a=s,*b=0,*e=0;
	int f=1;
	if(f==field)b=a;
	while(*a)
{		if(*a==delim)
{			f+=1;
			if(f==field)b=a+1;
			if(f==field+1)e=a;
}		a+=1;
}	f+=1;
	if(f==field+1)e=a;
	if(b&&e)
{		return strndup(b,e-b);
}	else
{		return NULL;//empty field (strdup("")) delimited implicitly;
}	/*-s option of man 1 cut can't be used to cut -f1 and is needed to cut -f2- from input with one field and no delimiter. so you might add an extra delimiter to the input.*/;
	/*cutr can operate on range, where extra empty implicit fields are ignored*/;
}char *cut_esc(char *s,int field,char delim)/*free result*/
{	char *a=s,*b=0,*e=0;
	int f=1;
	if(f==field)b=a;
	char slash=0;while(*a)
{		char c=*a;
		if(c=='/')slash=c;else if(c=='\\')slash=c;else
{			if(c==delim)
{				if(slash=='\\');else
{					f+=1;
					if(f==field)b=a+1;
					if(f==field+1)e=a;
}}			slash=0;
}		a+=1;
}	f+=1;
	if(f==field+1)e=a;
	if(b&&e)
{		//return strndup(b,e-b);
		char *out=zmalloc(1);char *a=b;
		char slash=0;while(a<e)
{			char c=*a;
			if(c=='/'||c=='\\')
{				if(slash)strpe_c(out,slash);slash=c;
}			else
{				if(c==delim)
{					if(slash=='\\')strpe_c(out,c);else
{						/*error*/;
}}				else
{					if(slash)strpe_c(out,slash);strpe_c(out,c);
}				slash=0;
}			a+=1;
}		if(1)//remove forward slash before nul //so unknown char-escaped string must always be followed by char or nul
{			if(slash=='/');else if(slash)strpe_c(out,slash);
}		return out;
}	else
{		return NULL;//empty field (strdup("")) delimited implicitly;
}}typedef tlist_t(int *) tlist_t_int;
typedef tlist_t(char **) tlist_t_charp;
/*todo remove below, use non-printing char. like 0x01*/;
inline void catstr_get(tlist_t_charp str_arr,tlist_t_int str_end_arr,int off,int len_out,char *out)
{	int arr_off=1;while(arr_off<=str_end_arr.len)
{		if(off<str_end_arr.a[arr_off])break;else arr_off+=1;
}	int n=0;char done=(off<0)?1:0;int s_off;goto lab_first;while(n<len_out)
{		out[n]=done?'\0':str_arr.a[arr_off][off-s_off];n+=1;
		off+=1;if(!done&&off>=str_end_arr.a[arr_off])
{			arr_off+=1;lab_first:;if(arr_off>str_end_arr.len)done=1;else
{				s_off=(arr_off==1)?0:str_end_arr.a[arr_off-1];}}}}
#define catstr1(arg) tlist(({tlist_t_charp catstrvar;catstrvar;}),arg)
#define catstr1_e(arg) tlist(({tlist_t_int catstrvar;catstrvar;}),strlen(arg))
char *cut_esc2(tlist_t_charp s,tlist_t_int s_end,tlist_t_charp s_o,tlist_t_int s_o_end,int field,char delim,char **out2_p)/*free 2 results*/{
	#define get(off,n) ({char macout[n];catstr_get(s,s_end,off,n,macout);macout;})
	#define get_o(off,n) ({char macout[n];catstr_get(s_o,s_o_end,off,n,macout);macout;})
	int a=0,b=-1,e=-1;
	int f=1;
	if(f==field)b=a;
	char slash=0;while(1)
{		char c=get(a,1)[0];if(c);else break;
		if(c=='/')slash=c;else if(c=='\\')slash=c;else
{			if(c==delim)
{				if(slash=='\\');else
{					f+=1;
					if(f==field)b=a+1;
					if(f==field+1)e=a;
}}			slash=0;
}		a+=1;
}	f+=1;
	if(f==field+1)e=a;
	if(b>=0&&e>=0)
{		//return strndup(b,e-b);
		char *out=zmalloc(1);int a=b;
		char *out2=zmalloc(1);
		char slash=0,s2;while(a<e)
{			char c=get(a,1)[0];
			char c2=get_o(a,1)[0];
			if(c=='/'||c=='\\')
{				if(slash)strpe_c(out,slash);slash=c;
				if(slash)strpe_c(out2,s2);s2=c2;
}			else
{				if(c==delim)
{					if(slash=='\\'){strpe_c(out,c);strpe_c(out2,c2);}else
{						/*error*/;
}}				else
{					if(slash)strpe_c(out,slash);strpe_c(out,c);
					if(slash)strpe_c(out2,s2);strpe_c(out2,c2);
}				slash=0;
}			a+=1;
}		if(1)//remove forward slash before nul //so unknown char-escaped string must always be followed by char or nul
{			if(slash=='/');else if(slash){strpe_c(out,slash);strpe_c(out2,s2);};
}		out2_p[0]=out2;return out;
}	else
{		out2_p[0]=NULL;return NULL;//empty field (strdup("")) delimited implicitly;
}	//;
	#undef get
	#undef get_o
}//









;
/*next n=1-2,4-5, arg. modified and returned*/;
#define nulroot(path_mac_arg) ({char *path_mac=path_mac_arg;if(*path_mac=='/'&&path_mac[1]=='\0')path_mac[0]='\0';path_mac;})
char *add_path(char *a,char *b)
{	int len_a=strlen(a);
	char *s=realloc(a,len_a+1+strlen(b)+1);
	s[len_a]='/';strcpy(s+len_a+1,b);
	return s;
}char check_ext(char *a,char *b)
{	int len_a=strlen(a),len_b=strlen(b);
	if(len_a>=len_b&&!strcmp(a+len_a-len_b,b))return 1;
	else return 0;
}char *add_ext(char *a,char *b)
{	int len_a=strlen(a),len_b=strlen(b);
	if(len_a>=len_b&&!strcmp(a+len_a-len_b,b));else strpe(a,b);
	return a;
}char *rem_ext(char *a,char *b)
{	int len_a=strlen(a),len_b=strlen(b);
	if(len_a>=len_b&&!strcmp(a+len_a-len_b,b))a[len_a-len_b]='\0';
	return a
;
}/*next 4, arg. modified and returned*/;
/*note std. lib. dirname basename ignore trailing slash on path.;
this dirname basename nextto, trailing slash on path is like "dir/."*/;
char *dirname_safe(char *path)
{	int len_path=strlen(path);
	if(len_path&&path[len_path-1]=='/')strpe_c(path,'.');
	stre(path,dirname(path));return path;
	//if(*path=='/'&&*out=='.')*out='/';
}char *basename_safe(char *path)
{	int len_path=strlen(path);
	if(len_path&&path[len_path-1]=='/')strpe_c(path,'.');
	stre(path,basename(path));return path;
}char *normpath(char *path)
{	char *a=path,*s=a;char next_rel=0;while(1)
{		char slash=(a[0]=='/'),slash_s=(s[0]=='/');
		char test=0;if(slash!=slash_s)test=1;else if(a[0]=='\0')test=2;
		if(test)
{			if(slash_s)
{				if(a-s>1||next_rel)
{					memmove(s+1-next_rel,a,strlen(a)+1);a=s+1-next_rel;
					next_rel=0;
}}			else
{				if(a-s==1&&!strncmp(s,".",a-s))
{					if(path<s)s-=1;
					if(s[0]!='/')next_rel=1;
					memmove(s,a,strlen(a)+1);a=s;
}				else if(a-s==2&&!strncmp(s,"..",a-s))
{					if(path<s)s-=1;
					while(path<s){if(s[0]=='/')break;s-=1;};
					if(s[0]!='/')next_rel=1;
					memmove(s,a,strlen(a)+1);a=s;
}}}		if(test==2)break;if(test)s=a;a+=1;
}	return path;
}char *abspath(char *base,char *path)
{	if(path[0]=='/')return path;else
{		char *path2=add_path(nulroot(strdup(base)),path);free(path);
		return normpath(path2)
;
}}char *read_cmd(char *cmd);
/*char *wd=getcwd(NULL,0);atend();free(wd)*/;
char *get_filename_self(char *argv0)/*free result*/
{	char *path;
	if(strchr(argv0,'/'))
{		char *wd=getcwd(NULL,0);
		path=abspath(wd,strdup(argv0)) ;free(wd);
}	else
{		char *cmd=strdupf("which %s",argv0);
		path=read_cmd(cmd);free(cmd);
}	return path;
}char *set_home(char *argv0)
{	char *dn=dirname_safe(get_filename_self(argv0));
	setenv("home",dn,1);free(dn);
	return getenv("home");
}char *nextto(char *fn1,char *bn2)/*free result*/
{	char *fn=strdup(fn1);int len_fn;char *bn=fn+strlen(fn);
	if(0)if(fn<bn&&bn[-1]=='/'){bn-=1 ;bn[0]='\0';};
	while(fn<bn&&bn[-1]!='/')bn-=1 ;bn[0]='\0';
	len_fn=strlen(fn) ;fn=realloc(fn,len_fn+strlen(bn2)+1);bn=fn+len_fn;strcpy(bn,bn2);return fn






;
}//typedef tlist_t(char **) tlist_t_charp;
void charplist_free(tlist_t_charp *arr_p)
{	int n=1;while(n<=arr_p->len)
{		free(arr_p->a[n]);
		n+=1;
}	free(arr_p->a);
	/**arr_p={.a=0,.len=0}*/;
}tlist_t_charp char_sep_unescape(char *s,char delim){
	#define c (*s)
	char *s1=s,*out=zmalloc(1);
	tlist_t_charp out2={.a=0,.len=0};
	if(1)
{		char slash=0;while(c)
{			if(c=='/'||c=='\\')
{				if(slash)strpe_c(out,slash);slash=c;
}			else
{				if(c==delim)
{					if(slash=='\\')strpe_c(out,c);else
{						/*break*/tlistpe(out2,out);out=zmalloc(1);
}}				else
{					if(slash)strpe_c(out,slash);strpe_c(out,c);
}				slash=0;
}			s+=1;
}		if(c=='\0')//remove forward slash before nul //so unknown char-escaped string must always be followed by char or nul
{			if(slash=='/');else if(slash)strpe_c(out,slash);
}		if(strlen(out)||!out2.len)tlistpe(out2,out);
		else free(out);
}	return out2;
	#undef c
}char *char_sep_escape(tlist_t_charp arr,char delim){
	#define c (*s)
	char *s,*s1;
	static char *out;if(out)free(out) ;out=zmalloc(1);
	int arr_n=1;char first=1;while(arr_n<=arr.len)
{		if(!first)strpe_c(out,delim);
		s=arr.a[arr_n];s1=s;
		while(c)
{			if(c==delim)strpe_c(out,'\\');
			strpe_c(out,c);
			s+=1;
}		if(s>s1)
{			s-=1;if(c=='/'||c=='\\')strpe_c(out,'/');
}		arr_n+=1;first=0;
}	return out;
	#undef c
}strlist carrot_sep_unescape(char *s){
	#define c (*s)
	char *s1=s,*out=zmalloc(1) ;char *pool="<>" ;char started=0;
	strlist out2={.a=0,.len=0,.off=0};
	if(1)
{		char slash=0;while(c)
{			if(c=='/'||c=='\\')
{				if(slash)strpe_c(out,slash);slash=c;
}			else
{				if(c==pool[0]||c==pool[1])
{					if(slash=='\\')strpe_c(out,c);else
{						/*break*/if(started||strlen(out))listpe(out2,out);else free(out);out=zmalloc(1) ;started=(c==pool[0])?1:0;
}}				else
{					if(slash)strpe_c(out,slash);if(!started&&strchr(" \t\r\n",c));else strpe_c(out,c);
}				slash=0;
}			s+=1;
}		if(c=='\0')//remove forward slash before nul //so unknown char-escaped string must always be followed by char or nul
{			if(slash=='/');else if(slash)strpe_c(out,slash);
}		if(strlen(out)||!out2.len)listpe(out2,out);
		else free(out);
}	return out2;
	#undef c
}char *carrot_sep_escape(strlist arr){
	#define c (*s)
	char *s,*s1 ;char *pool="<>";
	static char *out;if(out)free(out) ;out=zmalloc(1);
	int arr_n=0;while(arr_n<arr.len)
{		strpe_c(out,pool[0]);
		s=arr.a[arr_n];s1=s;if(!s)strpe(out,"(null)");else
{			while(c)
{				if(c==pool[0]||c==pool[1])strpe_c(out,'\\');
				strpe_c(out,c);
				s+=1;
}			if(s>s1)
{				s-=1;if(c=='/'||c=='\\')strpe_c(out,'/');
}}		strpe_c(out,pool[1]);
		arr_n+=1;
}	return out;
	#undef c
}tlist_t_charp sp_sep_unescape(char *s){
	#define c (*s)
	char *s1=s,*out=zmalloc(1);char out_set=0 ;char delim='\'';
	tlist_t_charp out2={.a=0,.len=0};
	if(1)
{		char slash=0;while(c)
{			if(c==' ')
{				if(slash)strpe_c(out,slash);
				if(strlen(out)||out_set)tlistpe(out2,out);else free(out);out=zmalloc(1);out_set=0;
				while(s[1]==' ')s+=1;slash=0;
}			else if(c=='/'||c=='\\')
{				if(slash)strpe_c(out,slash);slash=c;
}			else
{				if(c==delim)
{					if(slash=='\\')strpe_c(out,c);else
{						/*break*/while(s[1]==' '||s[1]==delim)
{							if(s[1]==' ')strpe_c(out,s[1]);s+=1;out_set=1;
}}}				else
{					if(slash)strpe_c(out,slash);strpe_c(out,c);
}				slash=0;
}			s+=1;
}		if(slash)strpe_c(out,slash);
		if(strlen(out)/*||!out2.len*/||out_set)tlistpe(out2,out);
		else free(out);
}	return out2;
	#undef c
}//;
#define sp_sep_escape1(s) sp_sep_escape((tlist_t_charp){.a=(char *[]){0,s},.len=1})
char *sp_sep_escape(tlist_t_charp arr){
	#define c (*s)
	char *s,*s1 ;char delim='\'';
	static char *out;if(out)free(out) ;out=zmalloc(1);
	int arr_n=1;char first=1;while(arr_n<=arr.len)
{		if(!first)strpe_c(out,' ');
		s=arr.a[arr_n];s1=s;
		while(1)
{			if((s1==s&&!c)||c==' ')
{				int len_out=strlen(out);char prev=!len_out?0:out[len_out-1];
				if(prev=='/'||prev=='\\')strpe_c(out,'/');
				strpe_c(out,delim);while(c==' ')
{					strpe_c(out,c);if(s[1]==' ')s+=1;else break;
}				strpe_c(out,delim);
}			else if(c)
{				if(c==delim)strpe_c(out,'\\');
				strpe_c(out,c);
}			if(!c)break;s+=1;
}		arr_n+=1;first=0;
}	return out;
	#undef c

}char *chars_unescape(char *s,int *len_s_io,char *pool,char *pool_rep,char opt_flip)/*free result*/
{	if(!pool_rep)pool_rep=pool;
	int len_s=-1;if(*len_s_io)len_s=*len_s_io;
	if(len_s==(int)-1)len_s=strlen(s);
	opt_flip=opt_flip?1:0;
	#define c (*s)
	char *s1=s,*out=zmalloc(1)/*,*out_m=zmalloc(1)*/;int len_out=0;int off=0;
	//#define strpe_c1(s,c) ({char macvar1=((c)=='\0')?'1':'0';strpe_c(s,(macvar1!='0')?macvar1:(c));strpe_c(s##_m,macvar1);});
	#define strpe_c1(s,c) lstrpe_c(s,c)
	if(1)
{		char slash=0;while(off<len_s)
{			if(c=='/'||c=='\\')
{				if(slash)strpe_c1(out,slash);slash=c;
}			else
{				char *res=strchr(pool_rep,c);
				if(res)
{					if((slash=='\\')^opt_flip)strpe_c1(out,c);else
{						/*break*/strpe_c1(out,pool[res-pool_rep]);
}}				else
{					if(slash)strpe_c1(out,slash);strpe_c1(out,c);
}				slash=0;
}			s+=1;off+=1;
}		if(slash)strpe_c1(out,slash);
}	len_s=/*strlen(out)*/len_out;if(len_s_io)*len_s_io=len_s;
	/*off=0;while(off<len_out)
{		if(out_m[off]!='0')out[off]='\0' ;off+=1;
}	*free(out_m)*/;
	return out;
	#undef c
	#undef strpe_c1
}char *chars_escape(char *s,int len_s,char *pool,char *pool_rep,char opt_flip)/*free result*/
{	if(len_s==(int)-1)len_s=strlen(s);
	if(!pool_rep)pool_rep=pool;
	#define c (*s)
	char *s1=s;
	#define strpe_c1(s,c) ({lstrpe_c(s,c);prev=c;})
	char *out=zmalloc(1);int len_out=0;char prev=0;
	int off=0;while(off<len_s)
{		char *res=strchr(pool,c);if(res)
{			if(opt_flip)strpe_c1(out,'\\');
			else if(prev=='/'||prev=='\\')strpe_c1(out,'/');
			strpe_c1(out,pool_rep[res-pool]);
}		else
{			char *res=strchr(pool_rep,c);
			if(opt_flip&&res){if(prev=='/'||prev=='\\')strpe_c1(out,'/');}
			else if(res)strpe_c1(out,'\\');
			strpe_c1(out,c);
}		s+=1;off+=1;
}	return out;
	#undef c
	#undef strpe_c1

}//#define _discardv __attribute__((cleanup(strv_free)));
#define strvf02 char **strv_for_func_var _discardv=NULL
#define strvf0 char **strv_for_func_var=NULL
#define strvf1(s) strv_add(&strv_for_func_var,s)
#define strvf_dup(s) strv_dup_(&strv_for_func_var,s)
#define strvf2 strv_free(&strv_for_func_var)
#define strv02 char **strv_var _discardv=NULL
#define strv0 char **strv_var=NULL
#define strv1(s) strv_add(&strv_var,s)
#define strv_dup(s) strv_dup_(&strv_var,s)
#define strv2 strv_free(&strv_var)
int strv_len(char ***strv_p)
{	if(!*strv_p)return 0;int len=0;char **av=*strv_p;
	while(av[0]){len+=1;av+=1;}return len;
}void strv_free(char ***strv_p)
{	if(!*strv_p)return;char **av=*strv_p;
	while(av[0]){free(av[0]);av+=1;};
	free(*strv_p);*strv_p=NULL;
}char *strv_add(char ***strv_p,char *str)
{	int len=strv_len(strv_p);
	len+=1;*strv_p=realloc(*strv_p,sizeof(char *)*(len+1));
	(*strv_p)[len-1]=str;(*strv_p)[len]=NULL;
	return str;
}char *strv_dup_(char ***strv_p,char *str)
{	if(!str)return str;char **av=*strv_p,**av1=av;
	while(av[0])
{		if(av[0]==str)
{			int len=strv_len(strv_p);memmove(av+1,av,len+1-(av+1-av1));break;
}		av+=1;
}	return str
;
}//use with "system()" //acts like "= str|args";
char *shell_esc(char *str)/*free result*/
{	char *out=malloc(strlen(str)+3);out[0]='\'';int len_out=1;
	char *a=str;while(a[0])
{		if(a[0]=='\'')
{			lstrpe_c(out,'\'');lstrpe_c(out,'\\');
}		lstrpe_c(out,a[0]);
		if(a[0]=='\'')lstrpe_c(out,'\'') ;a+=1;
}	lstrpe_c(out,'\'');lstrpe_c(out,'\0');return out


;
}struct pair
{	char *name;void *val;
};//;
typedef tlist_t(struct pair *) tlist_t_pair;
int pair_get(tlist_t_pair *tab_p,char *name,char creat,char *is_new_p)
{	int off=0;
	int n=1;while(n<=tab_p->len)
{		if(!strcmp(tab_p->a[n].name,name))
{			off=n;break;
}		n+=1;
}	if(!off&&creat)
{		if(is_new_p)*is_new_p=1;
		tlistpe(*tab_p,{.name=strdup(name),.val=NULL});off=tab_p->len;
}	else if(is_new_p)*is_new_p=0;
	return off;
}struct pair *pair_getp(tlist_t_pair *tab_p,char *name,char creat,char *is_new_p)
{	int off=pair_get(tab_p,name,creat,is_new_p);
	struct pair *nv=NULL;if(off)nv=&tab_p->a[off];
	return nv;
}char *get_printable(char c)/*ref. U0000.pdf U0080.pdf*/
{	static char *alpha_num="0123456789ABCDEF";
	static char str[]={'\\','x','0','0','\0'};char pr;
	if(!c)pr=0;
	else if(strchr(" \t\r\n",c))pr=1;
	else if((c&0x80)==0)
{		if((c&0xF0)>0x10)
{			if(c=='\x7F')pr=0;else pr=1;
}		else pr=0;
}	else pr=0;
	if(pr)return NULL;else
{		str[2]=alpha_num[(c&0xF0)/16];str[3]=alpha_num[(c&0x0F)];return str;
}}char *printable_unescape(char *s,int *len_return,char *pool,char *pool_rep,char opt_follow)/*free result*/
{	if(!pool)pool="";if(!pool_rep)pool_rep=pool;
	#define c (*s)
	char delim='x';const char opt_flip=0;
	char *s1=s,*out=zmalloc(1);int len_out=0;int off=0,len_s=strlen(s);
	#define strpe_c1(s,c) lstrpe_c(s,c)
	if(1)
{		char slash=0;while(off<len_s)
{			if(c=='/'||c=='\\')
{				if(slash)strpe_c1(out,slash);slash=c;
}			else
{				char test=(c==delim);char *res;if(!test)res=strchr(pool_rep,c);
				if(test||res)
{					if((slash=='\\')^opt_flip)
{						if(test)
{							char rep=0;
							if(off+1<len_s){s+=1;off+=1;rep=fromstr16(((char []){c,0}));};
							if(off+1<len_s){s+=1;off+=1;rep*=16;rep+=fromstr16(((char []){c,0}));};
							strpe_c1(out,rep);
}						else
{							strpe_c1(out,pool[res-pool_rep]);
}}					else
{						/*break*/strpe_c1(out,c);
}}				else
{					if(slash)strpe_c1(out,slash);strpe_c1(out,c);
}				slash=0;
}			s+=1;off+=1;
}		if(opt_follow&&slash=='/');else if(slash)strpe_c1(out,slash);
}	*len_return=len_out;return out;
	#undef c
	#undef strpe_c1
}char *printable_escape(char *s,int len_s,char *pool,char *pool_rep,char opt_follow)/*free result*/
{	if(len_s==(int)-1)len_s=strlen(s);
	if(!pool)pool="";if(!pool_rep)pool_rep=pool;
	#define c (*s)
	char *s1=s ;char delim='x';const char opt_flip=0;
	#define strpe_c1(s,c) ({lstrpe_c(s,c);prev=c;})
	char *out=zmalloc(1);int len_out=0;char prev=0;
	int off=0;while(off<len_s)
{		char test=(c==delim);char *res,*res2=NULL;
		if(!test)res=strchr(pool,c);if(!(test||res))res2=strchr1(pool_rep,c);
		if(test||res2)
{			if(opt_flip)strpe_c1(out,'\\');
			else if(prev=='/'||prev=='\\')strpe_c1(out,'/');
			strpe_c1(out,c);
}		else
{			//if(opt_flip&&res){if(prev=='/'||prev=='\\')strpe_c1(out,'/');}
			//else if(res)strpe_c1(out,'\\');
			if(res)c=pool_rep[res-pool];
			char *rep=get_printable(c);
			if(!rep&&res)strpe_c1(out,'\\');
			if(rep){strpe(out,rep);len_out=strlen(out);prev=0;}
			else strpe_c1(out,c);
}		s+=1;off+=1;
}	if(opt_follow)
{		if(prev=='/'||prev=='\\')strpe_c1(out,'/');
}	return out;
	#undef c
	#undef strpe_c1

}char *printable_backsl_unescape(char *s,int *len_return,char *pool,char *pool_rep)/*free result*/
{	if(!pool)pool="";if(!pool_rep)pool_rep=pool;
	#define c (*s)
	char delim='x';const char opt_flip=0;
	char *s1=s,*out=zmalloc(1);int len_out=0;int off=0,len_s=strlen(s);
	#define strpe_c1(s,c) lstrpe_c(s,c)
	if(1)
{		char slash=0;while(off<len_s)
{			if(c=='\\')
{				if(slash){strpe_c1(out,slash);slash=0;}else slash=c;
}			else
{				char test=(c==delim);char *res;if(!test)res=strchr(pool_rep,c);
				if(test||res)
{					if((slash=='\\')^opt_flip)
{						if(test)
{							char rep=0;
							if(off+1<len_s){s+=1;off+=1;rep=fromstr16(((char []){c,0}));};
							if(off+1<len_s){s+=1;off+=1;rep*=16;rep+=fromstr16(((char []){c,0}));};
							strpe_c1(out,rep);
}						else
{							strpe_c1(out,pool[res-pool_rep]);
}}					else
{						/*break*/strpe_c1(out,c);
}}				else
{					if(slash)strpe_c1(out,slash)/*warn unknown escape seq.*/;strpe_c1(out,c);
}				slash=0;
}			s+=1;off+=1;
}		if(slash)strpe_c1(out,slash);
}	*len_return=len_out;return out;
	#undef c
	#undef strpe_c1
}char *printable_backsl_escape(char *s,int len_s,char *pool,char *pool_rep)/*free result*/
{	if(len_s==(int)-1)len_s=strlen(s);
	if(!pool)pool="";if(!pool_rep)pool_rep=pool;
	#define c (*s)
	char *s1=s ;char delim2='\\';const char opt_flip=0;
	#define strpe_c1(s,c) ({lstrpe_c(s,c);prev=c;})
	char *out=zmalloc(1);int len_out=0;char prev=0;
	int off=0;while(off<len_s)
{		char test=(c==delim2);char *res;if(!test)res=strchr(pool,c);
		//if(opt_flip&&res){if(prev=='/'||prev=='\\')strpe_c1(out,'/');}
		//else if(res)strpe_c1(out,'\\');
		if(!test&&res)c=pool_rep[res-pool];
		char *rep=get_printable(c);
		if(!rep&&(test||res))strpe_c1(out,'\\');
		if(rep){strpe(out,rep);len_out=strlen(out);prev=0;}
		else strpe_c1(out,c);
		s+=1;off+=1;
}	return out;
	#undef c
	#undef strpe_c1
}