
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/stat.h>

#include <SDL2/SDL.h>

struct stat st
#define stif(x) #x
#define printq(format,...) printf(stif(format %s\n),__VA_ARGS__,stif((format,##__VA_ARGS__)))
#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))
#include "simple.c"

SDL_Window *window
SDL_Renderer *renderer
SDL_Texture *wintex
SDL_Surface *winsurf,*winsurf1 ;SDL_Surface *ap_surf,*ap_surf2
double zoom1=20 ;//for axes
typedef double num
num zoom2=10 ;//3d axes
double zoom=1 ;//>1 is bigger
//float zoomcx= 84*4-2, zoomcy= 92*2-1
char dirty=0,select_redraw=0,redraw=0

#include "recta.c"
rectm win_coord1
rectm win_abs ;//x,y is 0,0 always

int absx1(double cx)
	return ((int)(cx*zoom))+win_abs.w/2+win_coord1.x
int absy1(double cy)
	return ((int)(cy*zoom))+win_abs.h/2+win_coord1.y
double coordx1(int abx)
	return ((double)(abx-win_abs.w/2-win_coord1.x))/zoom
double coordy1(int aby)
	return ((double)(aby-win_abs.h/2-win_coord1.y))/zoom
#define absx2(cx) absx1(((double)(cx))*zoom1)
#define absy2(cy) absy1(-((double)(cy))*zoom1)
#define coordx2(abx) (coordx1(abx)/zoom1)
#define coordy2(aby) (-coordy1(aby)/zoom1)

void* sdl_v
#define sdl_(c,b,a,...) ({sdl_v=(void *)c##a(__VA_ARGS__);if((b>0&&sdl_v==NULL)||(b<=0&&((long)sdl_v)<b)){printf("SDL_%s failed: %s\n",#a, SDL_GetError());}sdl_v;})
#define sdl(b,a,...) sdl_(SDL_,b,a,__VA_ARGS__)

/*static*/ void quit(int ret)
	exit(ret)

void present_wrap1()
	/*look at example code SDL_GetWindowSurface.html*/
	static SDL_Surface *s
	if(!s)
		s=sdl(1,GetWindowSurface,window)
	SDL_BlitSurface(winsurf, NULL, s, NULL)
	// this works just like SDL_Flip
	SDL_UpdateWindowSurface(window)
void present_wrap()
	sdl(0,SetRenderTarget,renderer,NULL)
	SDL_RenderCopy(renderer, wintex, NULL, NULL)
	static SDL_Texture *t,*t1
	if(1)
		t=sdl(1,CreateTextureFromSurface,renderer,winsurf)
		t1=sdl(1,CreateTextureFromSurface,renderer,winsurf1)
		SDL_RenderCopy(renderer, t, NULL, NULL)
		SDL_RenderCopy(renderer, t1, NULL, NULL)
	SDL_RenderPresent(renderer)
	if(1)
		SDL_DestroyTexture(t)
		SDL_DestroyTexture(t1)
	sdl(0,SetRenderTarget,renderer,wintex)

void actionf3(int mx,int my,char mb,char mset)
void script1_lines()
void plot_g(double x,double y,int w)
#define set_gray() SDL_SetRenderDrawColor(renderer, 0xD0, 0xD0, 0xD0, 0xFF*0)
void win_sized()
#define drawall() script1(0,0)
void script1(int xx,int yy)
	//static Frame ok
	//ok=nue_fram()
	//Frame *lot=&fwin ;//=nue_fram()
	static int ww,hh;SDL_GetWindowSize(window,&ww,&hh)
	if(wintex&&(ww!=win_abs.w||hh!=win_abs.h))
		SDL_DestroyTexture(wintex) ;wintex=NULL
	char win_sized_flag=0
	if(!wintex) 
		wintex=sdl(1,CreateTexture,renderer,SDL_PIXELFORMAT_ARGB8888,SDL_TEXTUREACCESS_TARGET,ww,hh)
		win_sized_flag=1
	if(!winsurf) 
		ap_surf=winsurf=sdl(1,CreateRGBSurface,0,ww,hh,32,255<<8*2,255<<8*1,255,255<<8*3)
	if(!winsurf1)
		winsurf1=sdl(1,CreateRGBSurface,0,ww,hh,32,255<<8*2,255<<8*1,255,255<<8*3)
	sdl(0,FillRect,winsurf,NULL,0x00000000);//0x00FFFFFF)
	sdl(0,SetRenderTarget,renderer,wintex)
	xx=-xx ;yy=-yy
	xx+=win_coord1.x ;yy+=win_coord1.y
	set_rectm(&(win_coord1),xx,yy,ww/zoom,hh/zoom,0)
	//lot->dest.m=15
	set_rectm(&(win_abs),0,0,ww,hh,0)
	if(win_sized_flag) win_sized()
	//plot_g(100,100,8)

	if(1)
		set_gray()
		//SDL_SetRenderDrawBlendMode(renderer,SDL_BLENDMODE_NONE)
		SDL_RenderClear(renderer)
		sdl(0,FillRect,winsurf1,NULL,0);//text
		actionf3(0,0,0,0)
		dirty=1 ;select_redraw=1
		return
#include "draw.c"
//#include "action.c"
#include "main3d.c"
//#include "func.c"
void func_init()
	return
char func_arg_push(char type,int id,int x,int y)
	return 0
	//printf("obj_add1\n");fflush(stdout)
void redraw_selecions()
	#ifdef V2D
	if(new_item1_selected)
		new_item1_selected=0;func_arg_push(1,item1_selected,0,0)
	sdl(0,FillRect,winsurf1,NULL,0)
	qrect_surf=winsurf1
	draw_selected_item1()
	all_text(0,0,0,0)
	qrect_surf=NULL
	#endif

#define sdir (1) //scroll direction +-1
#define spdir (-1) //scroll direction +-1
void scroll_fp(rectm b1)
	dirty=1 ;//present_wrap() ;//script1(0,0)
	static int sw,sh
	sw=win_abs.w;//sw=win_coord1.w*zoom
	sh=win_abs.h;//sh=win_coord1.h*zoom
	sdl(0,SetRenderTarget,renderer,NULL)
	aline(0,spdir*(b1.h),sw,spdir*(b1.h))
	aline(0,sh+spdir*(b1.h),sw,sh+spdir*(b1.h))
	aline(spdir*(b1.w),0,spdir*(b1.w),sh)
	aline(sw+spdir*(b1.w),0,sw+spdir*(b1.w),sh)
	SDL_RenderPresent(renderer)
	sdl(0,SetRenderTarget,renderer,wintex)
void scroll_f(rectm b1)
	//print_rekt(b1)
	script1(-sdir*b1.w,-sdir*b1.h)
#include "windowevent.h_"

int skell=0
//int main(int argc, char *argv[])
static int done
static SDL_Event event
void testinit()
	func_init()
	/* Enable standard application logging */
	SDL_LogSetPriority(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO)

	int WINDOW_WIDTH=600,WINDOW_HEIGHT=520
	/*if (SDL_CreateWindowAndRenderer(WINDOW_WIDTH, WINDOW_HEIGHT, 0, &window, &renderer) < 0)
		quit(2)
	*///
	if(skell)
		long xid; xid=50331648
		sdl(0,Init,0)
		sdl(0,InitSubSystem,SDL_INIT_EVENTS) ;//events must be handled by window creator so whats the point
		sdl(0,VideoInit,NULL)
		//xid=hello_main()
		window=sdl(1,CreateWindowFrom,(void *)xid)
	else
		window=sdl(1,CreateWindow,"tsmin", SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED, WINDOW_WIDTH,WINDOW_HEIGHT, SDL_WINDOW_RESIZABLE)
	SDL_SetWindowPosition(window,0,40)
	renderer = sdl(1,CreateRenderer,window,-1,SDL_RENDERER_SOFTWARE)

	zoom=1
	win_coord1.x=-WINDOW_WIDTH/2;//-zoomcx
	win_coord1.y=-WINDOW_HEIGHT/2;//-zoomcy
	script1(0,0)
	/* Main render loop */
	////while(!skell){}
	done = 0

void testhook()
	char any=0
	if (!done)
		/* Check for events */
		while (1)
			char key1=KeyHook();if(key1)any=1
			char key2=KeyHook2(0);if(key2)any=1
			if(SDL_PollEvent(&event))
				any=1
				if (event.type == SDL_QUIT /*|| event.type == SDL_KEYDOWN*/||(event.type==SDL_WINDOWEVENT && event.window.event==SDL_WINDOWEVENT_CLOSE))
					done = 1
				if(1||skell)
					CheckWEvent(&event)
					CheckBEvent(&event)
					done = done || CheckKEvent(&event)
			else if(key1||key2);else break
			if(redraw)
				redraw=0;dirty=1;drawall()
			if(select_redraw)
				select_redraw=0;dirty=1;redraw_selecions()
			if(dirty)
				dirty=0 ;present_wrap()
			if(key1)usleep(20000/*20ms*/)
		//MoveSprites(renderer, sprite)
	if(done)
		//regurg_order()
		quit(0)
	if(!any)
		usleep(2000/*2ms*/)

int main_temp(int argc,char **argv)
	testinit()
	while(1)
		testhook()
