#!/usr/bin/python
def indent(line):
	i=0
	for a in line:
		if line[i]!=' ' and line[i]!='\t':
			break
		i+=1
	return line[:i]
def peek(f,nb):
	s=f.read(nb)
	#if not s: return s
	f.seek(-len(s),1)
	return s
def skip_comment():
	return skip_comment_(2)
def skip_comment_(com):
	global fsel,fsel_buf
	strip=1
	c=peek(fsel,1)
	if not c: return 0
	if com>0 and c=='*':
		buf=fsel_buf
		c=fsel.read(1) ;buf_c='/'+c
		while(1):
			c=read_until_('*',0) ;buf_c+=fsel_buf+c
			if peek(fsel,1)=='/': break
		c=fsel.read(1) ;buf_c+=c
		fsel_buf=buf
		if not strip: fsel_buf+=buf_c
		#if debug: fo.write("<rem "+buf_c+">")
		return 1
	elif com>1 and c=='/':
		buf=fsel_buf ;buf_c='/';read_until_('\r\n',0) ;buf_c+=fsel_buf ;fsel_buf=buf
		if not strip: fsel_buf+=buf_c
		#if debug: fo.write("<rem "+buf_c+">")
		return 1
	else: return 0
def read_until(pool):
	return read_until_(pool,2)
def read_until_(pool,com):
	global fsel,fsel_buf
	fsel_buf=''
	while 1:
		c=fsel.read(1)
		if not c: return c
		if c=='/' and skip_comment_(com): continue
		if pool.find(c)>=0: return c
		fsel_buf+=c
def read_while(pool):
	global fsel,fsel_buf
	fsel_buf=''
	while 1:
		c=fsel.read(1)
		if not c: return c
		if c=='/' and skip_comment(): continue
		if pool.find(c)<0: return c
		fsel_buf+=c
def read_brace():
	return read_brace2('{}')
def read_brace2(d):
	global fsel,fsel_buf
	level=1 ;fsel_buf=''
	while 1:
		c=fsel.read(1)
		if not c: return c
		if c=='/' and skip_comment(): continue
		level+=int(c==d[0])-int(c==d[1])
		if level<1: return c
		fsel_buf+=c
debug=0
#def process(end):
#	global a0,a1
#	if not end: a1=fsel.tell() ;fsel.seek(a0)
#	else: tmp=fsel.read(a1-fsel.tell()) ;a0=a1 ;return tmp
def process(end,file):
	global fsel
	if not end: f=open("/tmp/hed","wb") ;f.write(file) ;f.close() ;fsel=open("/tmp/hed","rb")
	else: tmp=fsel.read() ;fsel.close() ;fsel=fi ;return tmp
def process_dir(file,sta,extern,td,defi):
	if debug: fo.write("<process dir>"+file) ;return
	if sta: return
	global fsel
	process(0,file) ;buf=''
	c=read_until('#') ;buf+=fsel_buf+c
	c=read_while(' \t\r\n') ;buf+=fsel_buf
	fsel.seek(-1,1)
	c=read_until(' \t\r\n') ;buf+=fsel_buf+c
	if fsel_buf=="include" or fsel_buf=="line":
		return process(1,file)
	else:
		buf+=process(1,file) ;fo.write( buf)
def process_struct(file,sta,extern,td,defi):
	if debug: fo.write("<process struct>"+file) ;return
	if sta: return
	if not defi:
		process_var(file,sta,extern,td,defi)
		return
	global fsel
	process(0,file) ;buf=''
	c=read_until('{') ;buf+=fsel_buf+c
	c=read_brace() ;buf+=fsel_buf+c
	c=read_while(' \t\r\n') ;buf+=fsel_buf
	if sta: fo.write('\n#ifndef selfinc\n')
	if c==';' or td: fo.write(buf+c+process(1,file))
	else: fo.write(buf+"with_extern "+c+process(1,file))
	if sta: fo.write('\n#endif\n')
def process_func(file,sta,extern,td,defi):
	if debug: fo.write("<process func>"+file) ;return
	if not defi: return
	global fsel
	process(0,file) ;buf=''
	c=read_until('{;') ;buf+=fsel_buf #+c
	if c==';':
		return process(1,file) #caught earlier
	else:
		if sta: fo.write('\n#ifdef selfinc\n')
		#fo1=fo2 if sta else fo
		wuh=''
		while len(buf):
			if "\r\n\t ".find(buf[-1])<0: break
			wuh=buf[-1]+wuh;buf=buf[:-2+1]
		fo.write(buf+';'+wuh) ;del wuh
		if sta: fo.write('\n#endif\n')
		return process(1,file)
def process_var(file,sta,extern,td,defi):
	if debug: fo.write("<process var>"+file) ;return
	#if sta: return
	global fsel
	process(0,file) ;buf=''
	if td: fo.write(process(1,file));return
	c=read_while(' \t\r\n') ;buf+=fsel_buf
	fsel.seek(-1,1)
	c=read_until(' \t\r\n;') ;buf+=fsel_buf
	fsel.seek(-1,1)
	if(fsel_buf=="static"): #now earlier
		return process(1,file)
	c=read_while(' \t\r\n') ;buf+=fsel_buf
	fsel.seek(-1,1)
	if c!=';' and not extern and not sta: buf="with_extern "+buf
	while 1:
		c=read_until('=;') ;buf+=fsel_buf
		if c==';': break
		if c=='=': c=read_until(',;')
		if c==',': buf+=c
		if c==';': break
	if sta: fo.write('\n#ifdef selfinc\n')
	#fo1=fo2 if sta else fo
	fo.write(buf+c+process(1,file))
	if sta: fo.write('\n#endif\n')
	return
def main():
	global fsel, a0
	fsel=fi ;a0=fsel.tell()
	buf='' ;ind='' ;dir=0 #stack=[''] ;lineno=1;added=0 #gindent='';test=1 ;end='' ;dir2=0
	while 1:
		c=read_while(' \t\r\n') ;buf+=fsel_buf #; #fi.read(2) ;line=fsel_buf+'\r\n' #line=fi.readline()
		if not c: break #ind='' ;dir=0 ;break
		fi.seek(-1,1)
		c=read_until(' \t\r\n#;({') ;buf+=fsel_buf
		fi.seek(-1,1)
		#if debug: fo.write("<line "+line[:-2-1+1]+">")
		func=0 ;var=0 ;td=0 ;extern=0 ;sta=0 ;st=0 ;enumeration=0 ;defi=0 ;fptr=0 #kw
		if c=='#':
			#buf=c
			while 1:
				c=read_until('\r\n') ;buf+=fsel_buf
				if c:
					fi.seek(-2,1);c=fi.read(1)
					if fi.read(1)=='\r':
						if fi.read(1)!='\n': fi.seek(-1,1)
				buf+='\r\n'
				if c!='\\': break
			process_dir(buf,sta,extern,td,defi) ;buf='' ;continue
		elif fsel_buf=="struct": st=1
		elif fsel_buf=="enum": enumeration=1
		elif fsel_buf=="typedef": td=1
		elif fsel_buf=="static": sta=1
		elif fsel_buf=="extern": extern=1
		func=0
		c=read_while(' \t\r\n') ;buf+=fsel_buf
		if 0 and c=='(': buf+=c
		else: fi.seek(-1,1)
		c=read_until(' \t\r\n;({') ;buf+=fsel_buf
		fi.seek(-1,1)
		if st or fsel_buf=="struct": st=1
		if enumeration or fsel_buf=="enum": enumeration=1
		c=read_until(';({') ;buf+=fsel_buf
		fi.seek(-1,1)
		#if(c=='('): func=1
		if(c=='('):
			c=read_while(' \t\r\n') ;buf+=fsel_buf+c
			if c!='*': func=1
			else:
				c=read_until(';({') ;buf+=fsel_buf
				fi.seek(-1,1)
				if(c=='('): func=1 ;fptr=1
		c=read_until(';{') ;buf+=fsel_buf+c
		if func:
			if c=='{':  defi=1 ;c=read_brace() ;buf+=fsel_buf+c
			process_func(buf,sta,extern,td,defi);buf='' ;continue
		else:
			if c=='{':  defi=1 ;c=read_brace() ;buf+=fsel_buf+c ;c=read_until(';') ;buf+=fsel_buf+c
			if st: process_struct(buf,sta,extern,td,defi) ;buf='' ;continue
			elif enumeration: buf='' ;continue
			else: process_var(buf,sta,extern,td,defi) ;buf='' ;continue
		#if test: ind=gindent #or dir
		#if len(line.strip("\r\n"))==len(ind): fo.write(end);continue
		#fi.seek(-len(line)+len(ind),1)
		#struct=line[len(ind):].find('struct')==0
		#c=read_until('(;')
from sys import argv 
#import path from os
from os import popen
for a in argv:
	try: fi=open(a+".c","rb") #.cp
	except: continue
	fo=open(a+".h_","wb")
	#fo2=open(a+".hf_","wb")
	fo.write("#ifdef selfinc\n#define with_extern /**/\n#else\n#define with_extern extern\n#endif\n") #note gcc can't handle struct redefined i think #also see gcc -fno-common
	main()
	fo.write("\n#undef with_extern\n")
	fi.close();fo.close()
	#p=popen('mv -f '+a+".c_ "+a+".c") ;p.close()
##maybe use glib
##remove (nested) comments and trailing space
#fi=open("lisp.cp","rb")
#fo=open("lisp.c","wb")
