
typedef num *pnt
num segment(pnt p1,pnt p2)
pntp flat_p(pntp cp1)

/*
Curve[
B*(1,0,0)+x_1*(1-cos(a))+x_2*(1-sin(a)),
B*(0,1,0)+y_1*(1-cos(a))+y_2*(1-sin(a)),
B*(0,0,1)+z_1*(1-cos(a))+z_2*(1-sin(a)),a,0,90deg]

*/

typedef struct curve3
	num x_1,y_1,z_1;num x_2,y_2,z_2
	pntp B
curve3_t
void curve3_init(pntp p1,pntp p2,pntp p3,curve3_t *mem_p)
	num s_1=dist(p1,p2),s_2=dist(p3,p2)
	num a_1,b_1;num a_2,b_2
	a_1=aatan(p1.a[0]-p2.a[0],p1.a[1]-p2.a[1])
	b_1=aatan(segment(p1.a,p2.a),p1.a[2]-p2.a[2])
	mem_p->x_1=s_1*tr_x(a_1,b_1);mem_p->y_1=s_1*tr_y(a_1,b_1);mem_p->z_1=s_1*tr_z(a_1,b_1)
	a_2=aatan(p3.a[0]-p2.a[0],p3.a[1]-p2.a[1])
	b_2=aatan(segment(p3.a,p2.a),p3.a[2]-p2.a[2])
	mem_p->x_2=s_2*tr_x(a_2,b_2);mem_p->y_2=s_2*tr_y(a_2,b_2);mem_p->z_2=s_2*tr_z(a_2,b_2)
	mem_p->B=p2
pntp curve3(num a,curve3_t *mem_p)
	//,a,0,90deg
	pntp P
	P.a[0]=mem_p->B.a[0]+mem_p->x_1*(1-cos(ang(a)))+mem_p->x_2*(1-sin(ang(a)))
	P.a[1]=mem_p->B.a[1]+mem_p->y_1*(1-cos(ang(a)))+mem_p->y_2*(1-sin(ang(a)))
	P.a[2]=mem_p->B.a[2]+mem_p->z_1*(1-cos(ang(a)))+mem_p->z_2*(1-sin(ang(a)))
	return P

int curve3_tn=1
void curve3_draw(curve3_t *mem_p)
	num i=0;pntp pos
	while(i<=0.9/**1*/)
		//if(i+0.01<=0.9);else i=0.9
		pntp A,A_1
		A=curve3(i,mem_p);A_1=flat_p(A)
		if(i==0||i==0.9)adot(A_1.a[0],A_1.a[1],curve3_tn)
		if(i==0)pos=A_1	
		else while(1)
			signed char step[2];num d[2]
			d[0]=A_1.a[0]-pos.a[0];d[1]=A_1.a[1]-pos.a[1]
			step[0]=(d[0]>=1)-(d[0]<=-1)
			step[1]=(d[1]>=1)-(d[1]<=-1)
			pos.a[0]+=step[0];pos.a[1]+=step[1]
			if(fabs(d[0])<1&&fabs(d[1])<1)break
			adot(pos.a[0],pos.a[1],curve3_tn)
		i+=0.01