//typedef num pntp[3]
typedef struct pntp
	num a[3]
pntp;//
#define p_arg(name) name.a[0],name.a[1],name.a[2]
pntp scalar_mult(pntp p_,num n)
	num *p=p_.a
	p[0]*=n;p[1]*=n;p[2]*=n ;return p_
pntp scalar_mult2(num n,pntp p_)
	num *p=p_.a
	p[0]*=n;p[1]*=n;p[2]*=n ;return p_
pntp p_sub(pntp a_,pntp b_)
	num *a=a_.a,*b=b_.a
	a[0]-=b[0];a[1]-=b[1];a[2]-=b[2] ;return a_
num p_mult(pntp a_,pntp b_)
	num *a=a_.a,*b=b_.a
	return (a[0]*b[0]+a[1]*b[1]+a[2]*b[2])
num dist(pntp a_,pntp b_)
	num *a=a_.a,*b=b_.a
	//sqrt(sqrt(diffx2+diffy2)2+diffz2)
	num v1,v2=0
	v1=a[0]-b[0];v1*=v1;v2+=v1
	v1=a[1]-b[1];v1*=v1;v2+=v1
	v1=a[2]-b[2];v1*=v1;v2+=v1
	return sqrt(v2)

pntp get_p2(num px,num py,num pz){ pntp out;out.a[0]=px;out.a[1]=py;out.a[2]=pz;return out ;}
#define sq(u) ((u)*(u))
#define ang(x) ((x)*(2*M_PI/3.6))
#define dang(x) ((x)*(3.6/(2*M_PI)))
#define atan2(y,x) ({num macres=atan2(y,x);if(isnan(macres))macres=0;macres;})
#define atan2_(x,y) dang(atan2(y,x))
#define aatan(x,y) dang(atan2(y,x))
num tr_x(num aa,num ab){ return cos(ang(aa))*cos(ang(ab)) ;}
num tr_y(num aa,num ab){ return sin(ang(aa))*cos(ang(ab)) ;}
num tr_z(num aa,num ab){ return sin(ang(ab)) ;}
pntp tr_p(num aa,num ab)
	pntp p_;num *p=p_.a;p[0]=cos(ang(aa))*cos(ang(ab));p[1]=sin(ang(aa))*cos(ang(ab));p[2]=sin(ang(ab));return p_
//axz=atan(sin(ab)/(cos(ab)*cos(aa)))
//ayz=atan(sin(ab)/(cos(ab)*sin(aa)))
num axz(num aa,num ab){ return atan2_(cos(ang(aa)),tan(ang(ab))) ;}
num ayz(num aa,num ab){ return atan2_(sin(ang(aa)),tan(ang(ab))) ;}
num aa_f(pntp/*vect*/ u){ return aatan(u.a[0],u.a[1]) ;}
num ac_f(pntp/*vect*/ u){ return aatan(u.a[1],u.a[2]) ;}
num anorm1(num a)
	//normalize angle to -.9*2 to (not including) .9*2
	while(a<-0.9*2)a+=3.6 ;while(a>=0.9*2)a-=3.6 ;return a

pntp rotate(pntp P,num t,/*around*/pntp Q,pntp/*actually vect*/ u)
	num aa=aatan(u.a[0],u.a[1]),ab=aatan(sqrt(sq(u.a[0])+sq(u.a[1])),u.a[2])
	pntp u_1,u_2,u_3 ;num u_0
	pntp Q_1,P_1;num m,t_0,cx,cy,cz,ct_0,st_0;pntp ctmp;num tmp
	u_1=tr_p(aa,ab);u_2=get_p2(cos(ang(aa+0.9)),sin(ang(aa+0.9)),0);u_3=tr_p(aa,ab+0.9)
	u_0=p_mult(u,p_sub(P,Q))/p_mult(u,u_1)
	Q_1=p_sub(Q,scalar_mult2(-u_0,u_1))
	m=dist(P,Q_1);ctmp=scalar_mult(p_sub(P,Q_1),1.0/m)
	cx=ctmp.a[0];cy=ctmp.a[1];cz=ctmp.a[2]
	tmp=tr_z(aa,ab+0.9);if(/*tmp!=0*/!(tmp<0.01&&tmp>-0.01))
		st_0=cz/tmp
	else
		tmp=tr_x(aa,ab+0.9)-tr_y(aa,ab+0.9)/tan(ang(aa+0.9));st_0=(cx-cy/tan(ang(aa+0.9)))/tmp
	tmp=sin(ang(aa+0.9));if(/*tmp!=0*/!(tmp<0.01&&tmp>-0.01))
		ct_0=(cy-st_0*tr_y(aa,ab+0.9))/tmp
	else
		tmp=cos(ang(aa+0.9));ct_0=(cx-st_0*tr_x(aa,ab+0.9))/tmp
	t_0=aatan(ct_0,st_0)
	P_1=p_sub(Q_1,p_sub(scalar_mult2(-m*cos(ang(t_0+t)),u_2),scalar_mult2(m*sin(ang(t_0+t)),u_3)))
	return P_1
pntp point_of(num t,pntp p1_src,pntp p2_src)
	pntp P
	P.a[0]=p1_src.a[0]*t+p2_src.a[0]*(1-t)
	P.a[1]=p1_src.a[1]*t+p2_src.a[1]*(1-t)
	P.a[2]=p1_src.a[2]*t+p2_src.a[2]*(1-t)
	return P
num intersect(pntp p0,num a_1,num a_2,pntp p1_src,pntp p2_src)
	num x_0=p0.a[0],y_0=p0.a[1],z_0=p0.a[2]
	num x_1=p1_src.a[0],y_1=p1_src.a[1],z_1=p1_src.a[2]
	num x_2=p2_src.a[0],y_2=p2_src.a[1],z_2=p2_src.a[2]
	num c_1=cos(ang(a_1)),s_1=sin(ang(a_1)),c_2=cos(ang(a_2)),s_2=sin(ang(a_2))
	num c_3=cos(ang(a_1+0.9)),s_3=sin(ang(a_1+0.9))
	return ((c_1*c_2*s_3)*(z_0-z_2)+(c_1*s_2)*(y_2-y_0)+(c_2*c_3*s_1)*(z_2-z_0)+(s_1*s_2)*(x_0-x_2));
	/((c_1*c_2*s_3)*(z_1-z_2)+(c_1*s_2)*(y_2-y_1)+(c_2*c_3*s_1)*(z_2-z_1)+(s_1*s_2)*(x_1-x_2))